## khmer 2.0%2Bdfsg

=== lib/Makefile ===
# This file is part of khmer, https://github.com/dib-lab/khmer/, and is
# Copyright (C) 2010-2015, Michigan State University.
# Copyright (C) 2015, The Regents of the University of California.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
#     * Neither the name of the Michigan State University nor the names
#       of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written
#       permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Contact: khmer-project@idyll.org

# Should we use the standard system zlib and libbz2?

USE_SYSTEM_ZLIB ?= false
USE_SYSTEM_LIBBZ2 ?= false

# Profile?
# Set this variable to true if you wish to profile the codes.
WANT_PROFILING=false

# Which profiling tool to use?
# Assuming you have TAU installed and setup properly,
# you can instrument codes with it to get detailed multi-threaded profiling.
# Otherwise, gprof is able to give you some information without threading info.
# Choose one of: gprof, TAU
PROFILER_OF_CHOICE=gprof

# Perform extra sanity checking?
# Set this variable to true
# if you wish the codes to perform extra sanity checking
# (to the possible detriment of performance).
WANT_EXTRA_SANITY_CHECKING=false

# Compile with debugging symbols?
# Set this variable to true
# if you wish the codes to be built with debugging symbols
# (increases code size
# and does not always produce accurate stepping in a debugger
# when optimization is turned on).
WANT_DEBUGGING=false

PREFIX=/usr/local

### NOTE: No user-serviceable parts below this line! ###

INCLUDES= -I ../third-party/seqan/core/include/ 	\
	  -I ../third-party/smhasher/

ifeq ($(USE_SYSTEM_ZLIB), false)
INCLUDES += -I ../third-party/zlib/
endif

ifeq ($(USE_SYSTEM_LIBBZ2), false)
INCLUDES += -I ../third-party/bzip2/
endif

# Warnings in common to C and C++
WARNINGS=-Wall

# Flags in common to C and C++
COMMON_FLAGS=-O3 -fPIC
SEQAN_FLAGS=-DSEQAN_HAS_ZLIB=1 -DSEQAN_HAS_BZIP2=1

# Base C/CXXFLAGS
CPPFLAGS ?=
CPPFLAGS += $(SEQAN_FLAGS)

CXXFLAGS ?=
CXXFLAGS += $(COMMON_FLAGS) $(WARNINGS)
CXXFLAGS += -Wstrict-null-sentinel -std=c++11
CXXFLAGS += $(INCLUDES) $(CPPFLAGS)

CFLAGS	 ?=
CXXFLAGS += $(COMMON_FLAGS) $(WARNINGS)
CFLAGS   += -Wshadow -Wcast-align -Wstrict-prototypes
CFLAGS   += $(INCLUDES) $(CPPFLAGS)

LDFLAGS  ?=
ifneq ($(USE_SYSTEM_ZLIB), false)
LDFLAGS  += -lz
endif

ifneq ($(USE_SYSTEM_LIBBZ2), false)
LDFLAGS  += -lbz2
endif

ifeq ($(WANT_DEBUGGING), true)
DEBUG_FLAGS=-g
CXXFLAGS += $(DEBUG_FLAGS)
CFLAGS   += $(DEBUG_FLAGS)
endif

ifeq ($(WANT_EXTRA_SANITY_CHECKING), true)
DEFINE_KHMER_EXTRA_SANITY_CHECKS=-DKHMER_EXTRA_SANITY_CHECKS
CXXFLAGS += $(DEFINE_KHMER_EXTRA_SANITY_CHECKS)
CFLAGS   += $(DEFINE_KHMER_EXTRA_SANITY_CHECKS)
endif

ifeq ($(WANT_PROFILING), true)
ifeq ($(PROFILER_OF_CHOICE), TAU)
CXX=tau_cxx.sh
endif
ifeq ($(PROFILER_OF_CHOICE), gprof)
CXXFLAGS += -pg
CFLAGS   += -pg
LDFLAGS  += -pg
endif
endif

# Place POSIX threads last in linking order, if needed.
ifneq ($(shell uname), Linux)
LDFLAGS  += -pthread
endif


HAVE_OPENMP=$(shell 						\
	      $(CXX) -fopenmp -o chkomp .check_openmp.cc 	\
	      2>/dev/null && echo true || echo false; 		\
	      rm -f chkomp)

ifeq ($(HAVE_OPENMP), true)
CXXFLAGS +=-fopenmp
CFLAGS   +=-fopenmp
endif

ifneq ($(PACKAGE_VERSION),)
VERSION = $(PACKAGE_VERSION)
else
VERSION = $(shell ./get_version.py)
endif

# The ABI version of liboxli
LIB_VERSION = 1

ifeq ($(shell uname), Darwin)
SHARED_EXT   = dylib
SONAME       = liboxli.$(SHARED_EXT).$(LIB_VERSION)
SONAME_FLAGS = -install_name $(PREFIX)/lib/$(SONAME) \
	       -compatibility_version $(LIB_VERSION) \
	       -current_version $(LIB_VERSION)
else
SHARED_EXT   = so
SONAME       = liboxli.$(SHARED_EXT).$(LIB_VERSION)
SONAME_FLAGS = -Wl,-soname=$(SONAME)
endif

LIBKHMERSO=$(SONAME)

CXXFLAGS += -DVERSION=$(VERSION)

NO_UNIQUE_RC=0
CXXFLAGS += -DNO_UNIQUE_RC=$(NO_UNIQUE_RC)
CFLAGS   += -DNO_UNIQUE_RC=$(NO_UNIQUE_RC)

export CXX
export CFLAGS
export CXXFLAGS
export LDFLAGS
export VERSION


#### Third party dependencies ####
# ZLIB, use .lo not .o, so we get -fPIC and other library-related flags
ZLIB_DIR=../third-party/zlib
ZLIB_OBJS_BASE=\
	adler32.lo \
	crc32.lo \
	deflate.lo \
	infback.lo \
	inffast.lo \
	inflate.lo \
	inftrees.lo \
	trees.lo \
	zutil.lo \
	compress.lo \
	uncompr.lo \
	gzclose.lo \
	gzlib.lo \
	gzread.lo \
	gzwrite.lo

ZLIB_OBJS=$(addprefix $(ZLIB_DIR)/, $(ZLIB_OBJS_BASE))

# BZ2
BZIP2_DIR=../third-party/bzip2
BZIP2_OBJS_BASE= \
	blocksort.o \
	huffman.o \
	crctable.o \
	randtable.o \
	compress.o \
	decompress.o \
	bzlib.o

BZIP2_OBJS=$(addprefix $(BZIP2_DIR)/, $(BZIP2_OBJS_BASE))


#### oxli proper below here ####

LIBKHMER_OBJS= \
	counting.o \
	hashbits.o \
	hashtable.o \
	hllcounter.o \
	kmer_hash.o \
	labelhash.o \
	traversal.o \
	read_aligner.o \
	read_parsers.o \
	subset.o \
	murmur3.o

PRECOMILE_OBJS ?=
PRECLEAN_TARGS ?=

ifeq ($(USE_SYSTEM_ZLIB), false)
LIBKHMER_OBJS  += $(ZLIB_OBJS)
PRECOMILE_OBJS += $(ZLIB_OBJS)
PRECLEAN_TARGS += zlibclean
endif

ifeq ($(USE_SYSTEM_LIBBZ2), false)
LIBKHMER_OBJS  += $(BZIP2_OBJS)
PRECOMILE_OBJS += $(BZIP2_OBJS)
PRECLEAN_TARGS += libbz2clean
endif

KHMER_HEADERS= \
	counting.hh \
	hashbits.hh \
	hashtable.hh \
	khmer_exception.hh \
	khmer.hh \
	kmer_hash.hh \
	labelhash.hh \
	traversal.hh \
	read_aligner.hh \
	read_parsers.hh \
	subset.hh \

# START OF RULES #

# The all rule comes first!
all: $(LIBKHMERSO) liboxli.a oxli.pc

zlibclean:
	(cd $(ZLIB_DIR) && make distclean)
libbz2clean:
	(cd $(BZIP2_DIR) && make -f Makefile-libbz2_so clean)

clean: $(PRECLEAN_TARGS)
	rm -f *.o *.a *.$(SHARED_EXT)* oxli.pc $(TEST_PROGS)

install: $(LIBKHMERSO) liboxli.a oxli.pc $(KHMER_HEADERS)
	mkdir -p $(PREFIX)/lib $(PREFIX)/lib/pkgconfig $(PREFIX)/include/oxli
	cp -r $(KHMER_HEADERS) 				\
		../third-party/smhasher/MurmurHash3.h 	\
		$(PREFIX)/include/oxli/
	cp oxli.pc $(PREFIX)/lib/pkgconfig/
	cp $(LIBKHMERSO) liboxli.a $(PREFIX)/lib
	ln -sf $(PREFIX)/lib/$(LIBKHMERSO) $(PREFIX)/lib/liboxli.$(SHARED_EXT)

oxli.pc: oxli.pc.in
	sed -e 's,@prefix@,$(PREFIX),'  -e 's,@VERSION@,$(VERSION),' $< >$@

$(ZLIB_OBJS):
	(cd $(ZLIB_DIR) && ./configure && make $(ZLIB_OBJS_BASE))

$(BZIP2_OBJS):
	(cd $(BZIP2_DIR) && make -f Makefile-libbz2_so $(BZIP2_OBJS_BASE))

# MurMur3
murmur3.o: ../third-party/smhasher/MurmurHash3.cc
	$(CXX) $(CXXFLAGS) -c -o $@ $<

%.o: %.cc $(PRECOMILE_OBJS) $(KHMER_HEADERS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -c -o $@ $<

$(LIBKHMERSO): $(LIBKHMER_OBJS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SONAME_FLAGS) -shared -o $@ $^
	ln -sf $(SONAME) liboxli.$(SHARED_EXT)

liboxli.a: $(LIBKHMER_OBJS)
	ar rcs $@ $^
	ranlib $@

=== debian/control ===
Source: khmer
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
           Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-python,
               dh-exec,
               python3 (>= 3.3),
               python3-dev (>= 3.3),
               python3-all-dev (>= 3.3),
               python3-setuptools (>= 3.3),
               python3-screed,
               python3-nose,
               python3-sphinx,
               python3-sphinxcontrib.autoprogram,
               zlib1g-dev,
               libbz2-dev,
               asciidoctor
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/khmer.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/khmer.git
Homepage: http://khmer.readthedocs.org
X-Python-Version: 3.4

Package: khmer-common
Architecture: all
Multi-Arch: foreign
Depends: file,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: common files for the khmer project tools
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as
 that produced by the Illumina platform. khmer takes a k-mer-centric
 approach to sequence analysis, hence the name.
 .
 This package contains common files for liboxli and khmer

Package: khmer
Architecture: amd64 any-arm64 any-mips64 any-mips64el any-ia64 any-ppc64el any-sparc64
Multi-Arch: same
Depends: khmer-common,
         python3 (>= 3.3),
         python3-screed (<< 1.0),
         ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends}
Description: in-memory DNA sequence kmer counting, filtering & graph traversal
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as that
 produced by the Illumina platform. khmer takes a k-mer-centric approach to
 sequence analysis, hence the name.

Package: liboxli1
Architecture: amd64 any-arm64 any-mips64 any-mips64el any-ia64 any-ppc64el any-sparc64
Multi-Arch: same
Section: libs
Depends: khmer-common,
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: in-memory DNA sequence analysis library from the khmer project
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as that
 produced by the Illumina platform. khmer takes a k-mer-centric approach to
 sequence analysis, hence the name.
 .
 This package contains the low-level C++ library.

Package: liboxli-dev
Architecture: amd64 any-arm64 any-mips64 any-mips64el any-ia64 any-ppc64el any-sparc64
Multi-Arch: same
Section: libdevel
Depends: liboxli1 (= ${binary:Version}),
         ${misc:Depends},
         khmer-common
Description: in-memory DNA sequence analysis dev library
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as that
 produced by the Illumina platform. khmer takes a k-mer-centric approach to
 sequence analysis, hence the name.
 .
 This package contains the low-level C++ library headers and static archive.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
export PYBUILD_NAME=khmer
export PYBUILD_INSTALL_ARGS='--install-scripts=/usr/lib/khmer/bin'
export PYBUILD_DESTDIR_python3=debian/khmer

# Force C++ library build to use Debian zlib1g-dev/libbz2-dev
export USE_SYSTEM_ZLIB=true
export USE_SYSTEM_LIBBZ2=true

export PACKAGE_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')

export HOME=$(shell echo $$PWD"/fakehome")

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild --parallel

override_dh_auto_build:
	dh_auto_build
	ln -sf "`pwd`"/.pybuild/pythonX.Y_*/build/khmer/*.so khmer && \
		./setup.py develop --user && ./setup.py build_sphinx
	asciidoctor --backend manpage -a reproducible debian/khmer.1.adoc
	cd lib && $(MAKE) clean all

override_dh_auto_test:
	dh_auto_install
	PYBUILD_SYSTEM=custom \
	    PYBUILD_TEST_ARGS="cd {dir}; export PATH={destdir}/usr/lib/khmer/bin:$$PATH ; \
	    cd {build_dir}; {interpreter} -m nose --attr \
	    '!known_failing,!jenkins,!huge'" dh_auto_test


override_dh_auto_clean:
	#dh_auto_clean
	rm -f khmer/*.so
	rm -f debian/*.1
	cd lib && $(MAKE) clean
	rm -Rf fakehome

override_dh_install:
	cd lib && $(MAKE) PREFIX=../debian/tmp install
	dh_install
	find debian/khmer -name .gitignore -delete

get-orig-source:
	uscan --verbose --force-download --repack --compression xz

=== debian/watch ===
version=3

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/khmer-$1.tar.gz/" \
  https://github.com/dib-lab/khmer/releases .*/archive/v?(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## khmer 2.0+dfsg

=== Makefile ===
# This file is part of khmer, https://github.com/dib-lab/khmer/, and is
# Copyright (C) 2010-2015, Michigan State University.
# Copyright (C) 2015, The Regents of the University of California.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
#     * Neither the name of the Michigan State University nor the names
#       of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written
#       permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Contact: khmer-project@idyll.org

# make pep8 to check for basic Python code compliance
# make autopep8 to fix most pep8 errors
# make pylint to check Python code for enhanced compliance including naming
#  and documentation
# make coverage-report to check coverage of the python scripts by the tests

# `SHELL=bash` Will break Titus's laptop, so don't use BASH-isms like
# `[[` conditional expressions.
CPPSOURCES=$(wildcard lib/*.cc lib/*.hh khmer/_khmer.cc) setup.py
PYSOURCES=$(wildcard khmer/*.py scripts/*.py)
SOURCES=$(PYSOURCES) $(CPPSOURCES) setup.py
DEVPKGS=pep8==1.5.7 diff_cover autopep8 pylint coverage gcovr nose pep257 \
	screed

GCOVRURL=git+https://github.com/nschum/gcovr.git@never-executed-branches
VERSION=$(shell git describe --tags --dirty | sed s/v//)
CPPCHECK=ls lib/*.cc khmer/_khmer.cc | grep -v test | cppcheck -DNDEBUG \
	 -DVERSION=0.0.cppcheck -DSEQAN_HAS_BZIP2=1 -DSEQAN_HAS_ZLIB=1 \
	 -UNO_UNIQUE_RC --enable=all --suppress='*:/usr/*' \
	 --file-list=- --platform=unix64 --std=c++11 --inline-suppr \
	 --quiet -Ilib -Ithird-party/bzip2 -Ithird-party/zlib \
	 -Ithird-party/smhasher -I/usr/include/python3.4m -DHAVE_SSIZE_T \
	 -D__linux__ -D__x86_64__ -D__LP64__ -I/usr/include \
	 -I/usr/include/x86_64-linux-gnu/ -I/usr/include/linux \
	 -I/usr/lib/gcc/x86_64-linux-gnu/4.9/include/

UNAME := $(shell uname)
ifeq ($(UNAME),Linux)
	TESTATTR ?= '!known_failing,!jenkins,!huge'
else
	TESTATTR ?= '!known_failing,!jenkins,!huge,!linux'
endif


MODEXT=$(shell python -c "import sysconfig;print(sysconfig.get_config_var('SO'))")
EXTENSION_MODULE = khmer/_khmer$(MODEXT)

## all         : default task; compile C++ code, build shared object library
all: sharedobj

## help        : print this help message and exit
help: Makefile
	@sed -n 's/^##//p' $<

## install-dep : install most of the development dependencies via pip
install-dep: install-dependencies

install-dependencies:
	pip install --upgrade $(DEVPKGS)
	pip install --upgrade --requirement doc/requirements.txt

## sharedobj   : build khmer shared object file
sharedobj: $(EXTENSION_MODULE)

$(EXTENSION_MODULE): $(CPPSOURCES)
	./setup.py build_ext --inplace

coverage-debug: $(CPPSOURCES)
	export CFLAGS="-pg -fprofile-arcs -ftest-coverage -O0"; ./setup.py \
		build_ext --debug --inplace --libraries gcov
	touch coverage-debug

## install     : install the khmer module and scripts
install: FORCE
	./setup.py build install

## dist        : create a module package for distribution
dist: dist/khmer-$(VERSION).tar.gz

dist/khmer-$(VERSION).tar.gz: $(SOURCES)
	./setup.py sdist

## clean       : clean up all temporary / machine-generated files
clean: FORCE
	cd lib && ${MAKE} clean || true
	cd tests && rm -rf khmertest_* || true
	rm -f $(EXTENSION_MODULE)
	rm -f khmer/*.pyc lib/*.pyc scripts/*.pyc tests/*.pyc oxli/*.pyc
	./setup.py clean --all || true
	rm -f coverage-debug
	rm -Rf .coverage
	rm -f diff-cover.html

debug: FORCE
	export CFLAGS="-pg -fprofile-arcs -D_GLIBCXX_DEBUG_PEDANTIC \
		-D_GLIBCXX_DEBUG"; python setup.py build_ext --debug \
		--inplace

## doc         : render documentation in HTML
doc: build/sphinx/html/index.html

build/sphinx/html/index.html: $(SOURCES) $(wildcard doc/*.rst) doc/conf.py all
	./setup.py build_sphinx --fresh-env
	@echo ''
	@echo '--> docs in build/sphinx/html <--'
	@echo ''

## pdf         : render documentation as a PDF file
# packages needed include: texlive-latex-base texlive-latex-recommended
# texlive-fonts-recommended texlive-latex-extra
pdf: build/sphinx/latex/khmer.pdf

build/sphinx/latex/khmer.pdf: $(SOURCES) doc/conf.py $(wildcard doc/*.rst) \
	$(wildcard doc/user/*.rst) $(wildcard doc/dev/*.rst) sharedobj
	./setup.py build_sphinx --fresh-env --builder latex
	cd build/sphinx/latex && ${MAKE} all-pdf
	@echo ''
	@echo '--> pdf in build/sphinx/latex/khmer.pdf'

cppcheck-result.xml: $(CPPSOURCES)
	${CPPCHECK} --xml-version=2 2> cppcheck-result.xml

## cppcheck    : run static analysis on C++ code
cppcheck: $(CPPSOURCES)
	${CPPCHECK}

## pep8        : check Python code style
pep8: $(PYSOURCES) $(wildcard tests/*.py)
	pep8 --exclude=_version.py  --show-source --show-pep8 setup.py khmer/ \
		scripts/ tests/ oxli/ || true

pep8_report.txt: $(PYSOURCES) $(wildcard tests/*.py)
	pep8 --exclude=_version.py setup.py khmer/ scripts/ tests/ oxli/ \
		> pep8_report.txt || true

diff_pep8_report: pep8_report.txt
	diff-quality --violations=pep8 pep8_report.txt

## pep257      : check Python code style
pep257: $(PYSOURCES) $(wildcard tests/*.py)
	pep257 --ignore=D100,D101,D102,D103 \
		setup.py khmer/ scripts/ tests/ oxli/ || true

pep257_report.txt: $(PYSOURCES) $(wildcard tests/*.py)
	pep257 setup.py khmer/ scripts/ tests/ oxli/ \
		> pep257_report.txt 2>&1 || true

diff_pep257_report: pep257_report.txt
	diff-quality --violations=pep8 pep257_report.txt

## astyle      : fix most C++ code indentation and formatting
astyle: $(CPPSOURCES)
	astyle -A10 --max-code-length=80 $(CPPSOURCES)

## autopep8    : fix most Python code indentation and formatting
autopep8: $(PYSOURCES) $(wildcard tests/*.py)
	autopep8 --recursive --in-place --exclude _version.py --ignore E309 \
		setup.py khmer/*.py scripts/*.py tests/*.py oxli/*.py

# A command to automatically run astyle and autopep8 on appropriate files
## format      : check/fix all code indentation and formatting (runs astyle and autopep8)
format: astyle autopep8
	# Do nothing

## pylint      : run static code analysis on Python code
pylint: $(PYSOURCES) $(wildcard tests/*.py)
	pylint --msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
                --extension-pkg-whitelist=khmer \
		setup.py khmer/[!_]*.py khmer/__init__.py scripts/*.py tests \
		oxli/*.py || true

pylint_report.txt: ${PYSOURCES} $(wildcard tests/*.py)
	pylint --msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
		setup.py khmer/[!_]*.py khmer/__init__.py scripts/*.py tests \
		sandbox/*.py oxli/*.py > pylint_report.txt || true

diff_pylint_report: pylint_report.txt
	diff-quality --violations=pylint pylint_report.txt

# We need to get coverage to look at our scripts. Since they aren't in a
# python module we can't tell nosetests to look for them (via an import
# statement). So we run nose inside of coverage.
.coverage: $(PYSOURCES) $(wildcard tests/*.py) $(EXTENSION_MODULE)
	coverage run --branch --source=scripts,khmer,oxli --omit=khmer/_version.py \
		-m nose --with-xunit --attr $(TESTATTR) --processes=0

coverage.xml: .coverage
	coverage xml

coverage.html: htmlcov/index.html

htmlcov/index.html: .coverage
	coverage html
	@echo Test coverage of the Python code is now in htmlcov/index.html

coverage-report: .coverage
	coverage report

coverage-gcovr.xml: coverage-debug .coverage
	gcovr --root=. --branches --output=coverage-gcovr.xml --xml \
          --gcov-exclude='.*zlib.*|.*bzip2.*|.*smhasher.*|.*seqan.*' \
	  --exclude-unreachable-branches

diff-cover: coverage-gcovr.xml coverage.xml
	diff-cover coverage-gcovr.xml coverage.xml

diff-cover.html: coverage-gcovr.xml coverage.xml
	diff-cover coverage-gcovr.xml coverage.xml \
		--html-report diff-cover.html

nosetests.xml: FORCE
	./setup.py nosetests --with-xunit --attr ${TESTATTR}

## doxygen     : generate documentation of the C++ and Python code
# helpful packages: doxygen graphviz
# ignore warning re: _formulas.aux
doxygen: doc/doxygen/html/index.html

doc/doxygen/html/index.html: ${CPPSOURCES} ${PYSOURCES}
	mkdir -p doc/doxygen
	sed "s/\$${VERSION}/$$(python ./lib/get_version.py)/" Doxyfile.in | \
	 sed "s@\$${INCLUDES}@$$($$(gcc -print-prog-name=cc1plus) -v /dev/null \
	 2>&1 >/dev/null | grep '^ '|tr '\n' ' ')@" > Doxyfile
	doxygen

lib: FORCE
	cd lib && \
	$(MAKE)

# Runs a test of ./lib
libtest: FORCE
	rm -rf install_target
	mkdir -p install_target
	cd lib && \
	 $(MAKE) clean && \
	 $(MAKE) all && \
	 $(MAKE) install PREFIX=../install_target
	test -d install_target/include
	test -f install_target/include/oxli/khmer.hh
	test -d install_target/lib
	test -f install_target/lib/liboxli.a
	$(CXX) -std=c++11 -o install_target/test-prog-static -I install_target/include \
		lib/test-compile.cc install_target/lib/liboxli.a
	$(CXX) -std=c++11 -o install_target/test-prog-dynamic -I install_target/include \
		-L install_target/lib lib/test-compile.cc -loxli
	rm -rf install_target

## test        : run the khmer test suite
test: FORCE
	./setup.py develop
	./setup.py nosetests --attr ${TESTATTR}

sloccount.sc: ${CPPSOURCES} ${PYSOURCES} $(wildcard tests/*.py) Makefile
	sloccount --duplicates --wide --details lib khmer scripts tests \
		setup.py Makefile > sloccount.sc

## sloccount   : count lines of code
sloccount: 
	sloccount lib khmer scripts tests setup.py Makefile

coverity-build:
	if [ -x "${cov_analysis_dir}/bin/cov-build" ]; \
	then \
		export PATH=${PATH}:${cov_analysis_dir}/bin; \
		cov-build --dir cov-int --c-coverage gcov --disable-gcov-arg-injection make coverage-debug; \
		cov-capture --dir cov-int --c-coverage gcov python -m nose --attr ${TESTATTR} ; \
		cov-import-scm --dir cov-int --scm git 2>/dev/null; \
	else echo 'bin/cov-build does not exist in $$cov_analysis_dir: '\
		'${cov_analysis_dir}. Skipping coverity scan.'; \
	fi

coverity-upload: cov-int
	if [ -n "${COVERITY_TOKEN}" ]; \
	then \
		tar czf khmer-cov.tgz cov-int; \
		curl --form token=${COVERITY_TOKEN} --form \
			email=mcrusoe@msu.edu --form file=@khmer-cov.tgz \
			--form version=${VERSION} \
			https://scan.coverity.com/builds?project=ged-lab%2Fkhmer ; \
	else echo 'Missing coverity credentials in $$COVERITY_TOKEN,'\
		'skipping scan'; \
	fi

coverity-clean-configuration:
	rm -f ${cov_analysis_dir}/config/coverity_config.xml

coverity-configure:
	if [[ -x ${cov_analysis_dir}/bin/cov-configure ]]; \
	then \
		export PATH=${PATH}:${cov_analysis_dir}/bin; \
		for compiler in /usr/bin/gcc-4.8 /usr/bin/x86_64-linux-gnu-gcc; do \
       			cov-configure --comptype gcc --compiler $${compiler}; \
		done; \
	else echo 'bin/cov-configure does not exist in $$cov_analysis_dir: '\
		'${cov_analysis_dir}. Skipping coverity configuration.'; \
	fi

# may need to `sudo apt-get install bear`
compile_commands.json: clean
	export PATH=$(shell echo $$PATH | sed 's=/usr/lib/ccache:==g') ; \
		bear -- ./setup.py build_ext

convert-release-notes:

=== doc/requirements.txt ===
http://ci.oxli.org:8080/userContent/sphinxcontrib-autoprogram-0.1.1-khmerdev-20140331.tar.gz#egg=sphinxcontrib-autoprogram==0.1.1-khmerdev-20140331
setuptools==3.4.1

=== debian/changelog ===
khmer (2.0+dfsg-5) unstable; urgency=medium

  * Add 'appdata' about our IANA media type courtesy of Petter Reinholdtsen
    <pere@hungry.com>

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Fri, 05 Feb 2016 13:14:34 -0800

khmer (2.0+dfsg-4) unstable; urgency=medium

  [Michael Crusoe]
  * Put the khmer package in the 'science' section
  * Tighten arch support

  [Kevin Murray]
  * Add crunchbangs to postinst & postrm scripts

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Mon, 25 Jan 2016 05:35:34 -0800

khmer (2.0+dfsg-3) unstable; urgency=medium

  * Fixed DEP-8 test dependencies (tested with lxc instructions at
    https://ci.debian.net/doc/file.MAINTAINERS.html )

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Mon, 11 Jan 2016 11:59:11 -0800

khmer (2.0+dfsg-2) unstable; urgency=medium

  [Michael Crusoe]
  * Be explicit about architecture support
  * Set home directory for building the docs (Closes: #808424)

  [Kevin Murray]
  * Ensure that liboxli-dev depends on liboxli1

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Sun, 20 Dec 2015 01:24:57 -0800

khmer (2.0+dfsg-1) unstable; urgency=low

  * Initial upload (Closes: #777688)

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Wed, 09 Sep 2015 08:54:11 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: khmer
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
+Uploaders: Michael R. Crusoe <crusoe@ucdavis.edu>,
            Kevin Murray <spam@kdmurray.id.au>
 Section: science
 Priority: optional
@@ -17,8 +17,8 @@
                python3-sphinxcontrib.autoprogram,
                zlib1g-dev,
                libbz2-dev,
-               asciidoctor
-Standards-Version: 3.9.8
+               ruby-ronn
+Standards-Version: 3.9.6
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/khmer.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/khmer.git
 Homepage: http://khmer.readthedocs.org

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,8 @@
 	dh_auto_build
 	ln -sf "`pwd`"/.pybuild/pythonX.Y_*/build/khmer/*.so khmer && \
 		./setup.py develop --user && ./setup.py build_sphinx
-	asciidoctor --backend manpage -a reproducible debian/khmer.1.adoc
+	ronn -r --manual=khmer --organization='khmer project' \
+		debian/khmer.1.ronn
 	cd lib && $(MAKE) clean all
 
 override_dh_auto_test:

=== debian/tests/control ===
Tests: run-unit-test
       test-liboxli-dev
Depends: khmer,python3-nose,build-essential,zlib1g-dev,libbz2-dev,liboxli-dev
Restrictions: allow-stderr

## khmer 2.1.1+dfsg

=== Makefile ===
# This file is part of khmer, https://github.com/dib-lab/khmer/, and is
# Copyright (C) 2010-2015, Michigan State University.
# Copyright (C) 2015-2016, The Regents of the University of California.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
#     * Neither the name of the Michigan State University nor the names
#       of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written
#       permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Contact: khmer-project@idyll.org

# `make help` for a summary of useful targets

# `SHELL=bash` Will break Titus's laptop, so don't use BASH-isms like
# `[[` conditional expressions.
CPPSOURCES=$(wildcard lib/*.cc lib/*.hh khmer/_khmer.cc khmer/*.hh) setup.py
PYSOURCES=$(filter-out khmer/_version.py, \
	  $(wildcard khmer/*.py scripts/*.py oxli/*.py) )
SOURCES=$(PYSOURCES) $(CPPSOURCES) setup.py

DEVPKGS=pep8==1.6.2 diff_cover autopep8 pylint coverage gcovr pytest \
	pydocstyle pyenchant
GCOVRURL=git+https://github.com/nschum/gcovr.git@never-executed-branches

VERSION=$(shell ./setup.py version | grep Version | awk '{print $$4}' \
	| sed 's/+/-/')

# The following four variables are only used by cppcheck. If you want to
# change how things are compiled edit `setup.cfg` or `setup.py`.
DEFINES += -DNDEBUG -DVERSION=$(VERSION) -DSEQAN_HAS_BZIP2=1 \
	   -DSEQAN_HAS_ZLIB=1 -UNO_UNIQUE_RC

INCLUDESTRING=$(shell gcc -E -x c++ - -v < /dev/null 2>&1 >/dev/null \
	    | grep '^ /' | grep -v cc1plus)
INCLUDEOPTS=$(shell gcc -E -x c++ - -v < /dev/null 2>&1 >/dev/null \
	    | grep '^ /' | grep -v cc1plus | awk '{print "-I" $$1 " "}')
PYINCLUDE=$(shell python -c "from __future__ import print_function; \
	    import sysconfig; flags = ['-I' + sysconfig.get_path('include'), \
	    '-I' + sysconfig.get_path('platinclude')]; print(' '.join(flags))")

CPPCHECK_SOURCES=$(filter-out lib/test%, $(wildcard lib/*.cc khmer/_khmer.cc) )
CPPCHECK=cppcheck --enable=all \
	 --error-exitcode=1 \
	 --suppress='*:/Library/*' \
	 --suppress='*:*/include/python*/Python.h' \
	 --suppress='*:/usr/*' --platform=unix64 \
	 --std=c++11 --inline-suppr -Ilib -Ithird-party/bzip2 \
	 -Ithird-party/zlib -Ithird-party/smhasher \
	 $(DEFINES) $(INCLUDEOPTS) $(PYINCLUDE) $(CPPCHECK_SOURCES) --quiet

UNAME := $(shell uname)
ifeq ($(UNAME),Linux)
	TESTATTR ?= 'not known_failing and not jenkins and not huge'
else
	TESTATTR ?= 'not known_failing and not jenkins and not huge and not linux'
endif

MODEXT=$(shell python -c \
       "import sysconfig;print(sysconfig.get_config_var('SO'))")
EXTENSION_MODULE = khmer/_khmer$(MODEXT)

PYLINT_TEMPLATE="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}"

## all         : default task; compile C++ code, build shared object library
all: sharedobj

## help        : print this help message and exit
help: Makefile
	@sed -n 's/^##//p' $<

## install-dep : install most of the development dependencies via pip
install-dep: install-dependencies

install-dependencies:
	pip install --upgrade --ignore-installed $(DEVPKGS)
	pip install --upgrade --requirement doc/requirements.txt

## sharedobj   : build khmer shared object file
sharedobj: $(EXTENSION_MODULE)

$(EXTENSION_MODULE): $(CPPSOURCES)
	./setup.py build_ext --inplace

coverage-debug: $(CPPSOURCES)
	export CFLAGS="-pg -fprofile-arcs -ftest-coverage -O0"; ./setup.py \
		build_ext --debug --inplace --libraries gcov
	touch coverage-debug

## install     : install the khmer module and scripts
install: FORCE
	./setup.py build install

## dist        : create a module package for distribution
dist: dist/khmer-$(VERSION).tar.gz

dist/khmer-$(VERSION).tar.gz: $(SOURCES)
	./setup.py sdist

## clean       : clean up all temporary / machine-generated files
clean: FORCE
	cd lib && $(MAKE) clean || true
	cd tests && rm -rf khmertest_* || true
	rm -f pytest_runner-*.egg pytests.xml
	rm -f $(EXTENSION_MODULE)
	rm -f khmer/*.pyc lib/*.pyc scripts/*.pyc tests/*.pyc oxli/*.pyc \
		sandbox/*.pyc khmer/__pycache__/* sandbox/__pycache__/*
	./setup.py clean --all || true
	rm -f coverage-debug
	rm -Rf .coverage coverage-gcovr.xml coverage.xml
	rm -f diff-cover.html
	rm -Rf build dist
	rm -rf __pycache__/ .eggs/ khmer.egg-info/
	-rm -f *.gcov

debug: FORCE
	export CFLAGS="-pg -fprofile-arcs -D_GLIBCXX_DEBUG_PEDANTIC \
		-D_GLIBCXX_DEBUG -DDEBUG_ASSEMBLY=1 -DDEBUG_FILTERS=1"; python setup.py build_ext --debug \
		--inplace

## doc         : render documentation in HTML
doc: build/sphinx/html/index.html

build/sphinx/html/index.html: $(SOURCES) $(wildcard doc/*.rst) doc/conf.py all
	./setup.py build_sphinx --fresh-env
	@echo ''
	@echo '--> docs in build/sphinx/html <--'
	@echo ''

## pdf         : render documentation as a PDF file
# packages needed include: texlive-latex-base texlive-latex-recommended
# texlive-fonts-recommended texlive-latex-extra
pdf: build/sphinx/latex/khmer.pdf

build/sphinx/latex/khmer.pdf: $(SOURCES) doc/conf.py $(wildcard doc/*.rst) \
	$(wildcard doc/user/*.rst) $(wildcard doc/dev/*.rst) sharedobj
	./setup.py build_sphinx --fresh-env --builder latex
	cd build/sphinx/latex && $(MAKE) all-pdf
	@echo ''
	@echo '--> pdf in build/sphinx/latex/khmer.pdf'

cppcheck-result.xml: $(CPPSOURCES)
	$(CPPCHECK) --xml-version=2 2> cppcheck-result.xml

## cppcheck    : run static analysis on C++ code
cppcheck: FORCE
	@$(CPPCHECK)

cppcheck-long: FORCE
	@$(CPPCHECK) -Ithird-party/seqan/core/include

## pep8        : check Python code style
pep8: $(PYSOURCES) $(wildcard tests/*.py)
	pep8 setup.py khmer/*.py scripts/*.py tests/*.py oxli/*.py

pep8_report.txt: $(PYSOURCES) $(wildcard tests/*.py)
	pep8 setup.py khmer/ scripts/ tests/ oxli/ \
		> pep8_report.txt || true

diff_pep8_report: pep8_report.txt
	diff-quality --violations=pep8 pep8_report.txt

## pydocstyle  : check Python doc strings
pydocstyle: $(PYSOURCES) $(wildcard tests/*.py)
	pydocstyle --ignore=D100,D101,D102,D103,D203 --match='(?!_version).*\.py' \
		setup.py khmer/ scripts/ oxli/ || true

pydocstyle_report.txt: $(PYSOURCES) $(wildcard tests/*.py)
	pydocstyle setup.py khmer/ scripts/ tests/ oxli/ \
		> pydocstyle_report.txt 2>&1 || true

diff_pydocstyle_report: pydocstyle_report.txt
	diff-quality --violations=pep8 pydocstyle_report.txt

## astyle      : fix most C++ code indentation and formatting
astyle: $(CPPSOURCES)
	astyle -A10 --max-code-length=80 $(filter-out setup.py,$(CPPSOURCES))

## autopep8    : fix most Python code indentation and formatting
autopep8: $(PYSOURCES) $(wildcard tests/*.py)
	autopep8 --recursive --in-place --exclude _version.py --ignore E309 \
		setup.py khmer/*.py scripts/*.py tests/*.py oxli/*.py

## format      : check/fix all code formatting (astyle and autopep8)
format: astyle autopep8
	# Do nothing

## pylint      : run static code analysis on Python code
pylint: $(PYSOURCES) $(wildcard tests/*.py)
	pylint --msg-template=$(PYLINT_TEMPLATE) \
		setup.py $(PYSOURCES) tests/*.py || true

pylint_report.txt: $(PYSOURCES) $(wildcard tests/*.py) $(wildcard sandbox/*.py)
	pylint --msg-template=$(PYLINT_TEMPLATE) \
		$(PYSOURCES) tests sandbox > pylint_report.txt || true

diff_pylint_report: pylint_report.txt
	diff-quality --violations=pylint pylint_report.txt

# We need to get coverage to look at our scripts. Since they aren't in a
# python module we can't tell pytest to look for them (via an import
# statement). So we run pytest inside of coverage.
.coverage: $(PYSOURCES) $(wildcard tests/*.py) $(EXTENSION_MODULE)
	./setup.py develop
	coverage run --branch --source=scripts,khmer,oxli \
		--omit=khmer/_version.py -m pytest --junitxml=pytests.xml \
		-m $(TESTATTR)

coverage.xml: .coverage
	coverage xml

coverage.html: htmlcov/index.html

htmlcov/index.html: .coverage
	coverage html
	@echo Test coverage of the Python code is now in htmlcov/index.html

coverage-report: .coverage
	coverage report

coverage-gcovr.xml: coverage-debug .coverage
	gcovr --root=. --branches --output=coverage-gcovr.xml --xml \
          --gcov-exclude='.*zlib.*|.*bzip2.*|.*smhasher.*|.*seqan.*' \
	  --exclude-unreachable-branches

diff-cover: coverage-gcovr.xml coverage.xml
	diff-cover coverage-gcovr.xml coverage.xml

diff-cover.html: coverage-gcovr.xml coverage.xml
	diff-cover coverage-gcovr.xml coverage.xml \
		--html-report diff-cover.html

pytests.xml: FORCE
	py.test --junitxml=$@ -m ${TESTATTR}

## doxygen     : generate documentation of the C++ and Python code
# helpful packages: doxygen graphviz
# ignore warning re: _formulas.aux
doxygen: doc/doxygen/html/index.html

doc/doxygen/html/index.html: $(CPPSOURCES) $(PYSOURCES)
	mkdir -p doc/doxygen
	sed "s=\$${VERSION}=$$(python ./lib/get_version.py)=" Doxyfile.in | \
		sed "s=\$${INCLUDES}=$(INCLUDESTRING)=" > Doxyfile
	doxygen

lib: FORCE
	cd lib && \
	$(MAKE)

# Runs a test of ./lib
libtest: FORCE
	rm -rf install_target
	mkdir -p install_target
	cd lib && \
	 $(MAKE) clean && \
	 $(MAKE) all && \
	 $(MAKE) install PREFIX=../install_target
	test -d install_target/include
	test -f install_target/include/oxli/khmer.hh
	test -d install_target/lib
	test -f install_target/lib/liboxli.a
	$(CXX) -std=c++11 -o install_target/test-prog-static \
		-I install_target/include lib/test-compile.cc \
		install_target/lib/liboxli.a
	$(CXX) -std=c++11 -o install_target/test-prog-dynamic \
		-I install_target/include -L install_target/lib \
		lib/test-compile.cc -loxli
	rm -rf install_target

## test        : run the khmer test suite
test: FORCE
	./setup.py develop
	py.test -m ${TESTATTR}

sloccount.sc: $(CPPSOURCES) $(PYSOURCES) $(wildcard tests/*.py) Makefile
	sloccount --duplicates --wide --details lib khmer scripts tests \
		setup.py Makefile > sloccount.sc

## sloccount   : count lines of code
sloccount:
	sloccount lib khmer scripts tests setup.py Makefile

coverity-build:
	if [ -x "${cov_analysis_dir}/bin/cov-build" ]; \
	then \
		export PATH=${PATH}:${cov_analysis_dir}/bin; \
		cov-build --dir cov-int --c-coverage gcov \
			--disable-gcov-arg-injection make coverage-debug; \
		cov-capture --dir cov-int --c-coverage gcov python -m pytest \
			-m $(TESTATTR) ; \
		cov-import-scm --dir cov-int --scm git 2>/dev/null; \
	else echo 'bin/cov-build does not exist in $$cov_analysis_dir: '\
		'${cov_analysis_dir}. Skipping coverity scan.'; \
	fi

coverity-upload: cov-int
	if [ -n "${COVERITY_TOKEN}" ]; \
	then \
		tar czf khmer-cov.tgz cov-int; \
		curl --form token=${COVERITY_TOKEN} --form \
			email=mcrusoe@msu.edu --form file=@khmer-cov.tgz \
			--form version=$(VERSION) \
			https://scan.coverity.com/builds?project=ged-lab%2Fkhmer ; \
	else echo 'Missing coverity credentials in $$COVERITY_TOKEN,'\
		'skipping scan'; \
	fi

coverity-clean-configuration:
	rm -f ${cov_analysis_dir}/config/coverity_config.xml

coverity-configure:

=== doc/requirements.txt ===
sphinxcontrib-autoprogram==0.1.2
setuptools>=3.4.1
guzzle_sphinx_theme==0.7.11

=== lib/Makefile ===
--- 
+++ 
@@ -150,7 +150,7 @@
 ifneq ($(PACKAGE_VERSION),)
 VERSION = $(PACKAGE_VERSION)
 else
-VERSION = $(shell ./get_version.py)
+VERSION = $(./setup.py version | grep Version | awk '{print $2}')
 endif
 
 # The ABI version of liboxli
@@ -222,9 +222,8 @@
 #### oxli proper below here ####
 
 LIBKHMER_OBJS= \
-	counting.o \
-	hashbits.o \
 	hashtable.o \
+	hashgraph.o \
 	hllcounter.o \
 	kmer_hash.o \
 	labelhash.o \
@@ -232,7 +231,11 @@
 	read_aligner.o \
 	read_parsers.o \
 	subset.o \
-	murmur3.o
+	kmer_filters.o \
+	assembler.o \
+	alphabets.o \
+	murmur3.o \
+	storage.o
 
 PRECOMILE_OBJS ?=
 PRECLEAN_TARGS ?=
@@ -250,9 +253,8 @@
 endif
 
 KHMER_HEADERS= \
-	counting.hh \
-	hashbits.hh \
 	hashtable.hh \
+	hllcounter.hh \
 	khmer_exception.hh \
 	khmer.hh \
 	kmer_hash.hh \
@@ -261,6 +263,10 @@
 	read_aligner.hh \
 	read_parsers.hh \
 	subset.hh \
+	kmer_filters.hh \
+	assembler.hh \
+	alphabets.hh \
+	storage.hh
 
 # START OF RULES #

=== examples/c++-api/Makefile ===
CFLAGS=--std=c++11 \
       -I ../../lib \
	   -I ../../third-party/smhasher \
	   -I ../../third-party/seqan/core/include/

run: all
	./exact-counting
	./bloom
	./consume reads.fastq

all: exact-counting bloom consume

clean:
	-rm -f exact-counting bloom consume

%: %.cc ../../lib/liboxli.a
	$(CXX) $(CFLAGS) -o $* $*.cc ../../lib/liboxli.a

../../lib/liboxli.a:
	cd ../../lib && make

=== debian/changelog ===
khmer (2.1.1+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Remove empty field

  [ Michael R. Crusoe ]
  * New upstream version 2.1.1
  * Incorporate patch from Ubuntu, thank you Michael Hudson-Doyle.
    Closes: #862380

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 29 Aug 2017 23:30:09 -0700

khmer (2.0+dfsg-10ubuntu1) artful; urgency=medium

  * Fix build with Python 3.6.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 12 May 2017 13:15:00 +1200

khmer (2.0+dfsg-10) unstable; urgency=medium

  * Team upload.
  * Revert "Drop arm64 due to failing tests."  Closes: #859752

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 06 Apr 2017 22:02:24 +0200

khmer (2.0+dfsg-9) unstable; urgency=medium

  * Drop arm64 due to failing tests. (Closes: #851830)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 24 Jan 2017 07:37:50 -0800

khmer (2.0+dfsg-8) unstable; urgency=medium

  * Team upload.
  * Enable static building ('--static') with pkg-config.
  * Have autopkgtests use pkg-config.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 15 Jan 2017 13:13:43 +0000

khmer (2.0+dfsg-7) unstable; urgency=medium

  * make build reproducible

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 23 May 2016 12:55:46 -0700

khmer (2.0+dfsg-6) unstable; urgency=medium

  * Switch from deprecated ruby-ronn to asciidoctor for manpage generation
  * Bump Standards-Version to 3.9.8

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 04 May 2016 11:25:30 -0700

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,26 @@
 Source: khmer
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <crusoe@ucdavis.edu>,
+Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
            Kevin Murray <spam@kdmurray.id.au>
 Section: science
 Priority: optional
 Build-Depends: debhelper (>= 9),
                dh-python,
                dh-exec,
+               python3-guzzle-sphinx-theme,
                python3 (>= 3.3),
                python3-dev (>= 3.3),
                python3-all-dev (>= 3.3),
                python3-setuptools (>= 3.3),
-               python3-screed,
-               python3-nose,
+               python3-screed (>= 1.0),
+               python3-pytest,
+               python3-pytest-runner,
                python3-sphinx,
                python3-sphinxcontrib.autoprogram,
                zlib1g-dev,
                libbz2-dev,
-               ruby-ronn
-Standards-Version: 3.9.6
+               asciidoctor
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/khmer.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/khmer.git
 Homepage: http://khmer.readthedocs.org
@@ -43,7 +45,7 @@
 Multi-Arch: same
 Depends: khmer-common,
          python3 (>= 3.3),
-         python3-screed (<< 1.0),
+         python3-screed (>= 1.0),
          ${shlibs:Depends},
          ${misc:Depends},
          ${python3:Depends}

=== debian/rules ===
--- 
+++ 
@@ -8,8 +8,6 @@
 export USE_SYSTEM_ZLIB=true
 export USE_SYSTEM_LIBBZ2=true
 
-export PACKAGE_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
-
 export HOME=$(shell echo $$PWD"/fakehome")
 
 %:
@@ -19,16 +17,15 @@
 	dh_auto_build
 	ln -sf "`pwd`"/.pybuild/pythonX.Y_*/build/khmer/*.so khmer && \
 		./setup.py develop --user && ./setup.py build_sphinx
-	ronn -r --manual=khmer --organization='khmer project' \
-		debian/khmer.1.ronn
+	asciidoctor --backend manpage -a reproducible debian/khmer.1.adoc
 	cd lib && $(MAKE) clean all
 
 override_dh_auto_test:
 	dh_auto_install
 	PYBUILD_SYSTEM=custom \
 	    PYBUILD_TEST_ARGS="cd {dir}; export PATH={destdir}/usr/lib/khmer/bin:$$PATH ; \
-	    cd {build_dir}; {interpreter} -m nose --attr \
-	    '!known_failing,!jenkins,!huge'" dh_auto_test
+	    cd {build_dir}; export PYTHONPATH=$$(pwd); {interpreter} -m pytest \
+	    -m 'not known_failing and not jenkins and not huge'" dh_auto_test
 
 
 override_dh_auto_clean:
@@ -43,5 +40,8 @@
 	dh_install
 	find debian/khmer -name .gitignore -delete
 
+override_dh_sphinxdoc:
+	dh_sphinxdoc -X jquery.js
+
 get-orig-source:
 	uscan --verbose --force-download --repack --compression xz
